Active Directory Connectors - Create

Creates or replaces an Active Directory connector resource.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.AzureArcData/dataControllers/{dataControllerName}/activeDirectoryConnectors/{activeDirectoryConnectorName}?api-version=2026-01-01

URI Parameters

Name In Required Type Description
activeDirectoryConnectorName
path True

string

The name of the Active Directory connector instance

dataControllerName
path True

string

The name of the data controller

resourceGroupName
path True

string

The name of the Azure resource group

subscriptionId
path True

string

The ID of the Azure subscription

api-version
query True

string

The API version to use for the request

Request Body

Name Required Type Description
properties True

ActiveDirectoryConnectorProperties

null

Responses

Name Type Description
200 OK

ActiveDirectoryConnectorResource

OK

201 Created

ActiveDirectoryConnectorResource

Created

Other Status Codes

ErrorResponse

*** Error Responses: ***

Examples

Create or update an Active Directory connector instance.

Sample request

PUT https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.AzureArcData/dataControllers/testdataController/activeDirectoryConnectors/testADConnector?api-version=2026-01-01

{
  "properties": {
    "spec": {
      "activeDirectory": {
        "realm": "CONTOSO.LOCAL",
        "serviceAccountProvisioning": "manual",
        "domainControllers": {
          "primaryDomainController": {
            "hostname": "dc1.contoso.local"
          },
          "secondaryDomainControllers": [
            {
              "hostname": "dc2.contoso.local"
            },
            {
              "hostname": "dc3.contoso.local"
            }
          ]
        }
      },
      "dns": {
        "nameserverIPAddresses": [
          "11.11.111.111",
          "22.22.222.222"
        ],
        "replicas": 1,
        "preferK8sDnsForPtrLookups": false
      }
    }
  }
}

Sample response

{
  "properties": {
    "spec": {
      "activeDirectory": {
        "realm": "CONTOSO.LOCAL",
        "serviceAccountProvisioning": "manual",
        "domainControllers": {
          "primaryDomainController": {
            "hostname": "dc1.contoso.local"
          },
          "secondaryDomainControllers": [
            {
              "hostname": "dc2.contoso.local"
            },
            {
              "hostname": "dc3.contoso.local"
            }
          ]
        },
        "netbiosDomainName": "CONTOSO"
      },
      "dns": {
        "nameserverIPAddresses": [
          "11.11.111.111",
          "22.22.222.222"
        ],
        "replicas": 1,
        "preferK8sDnsForPtrLookups": false,
        "domainName": "contoso.local"
      }
    }
  },
  "systemData": {
    "createdBy": "user1",
    "createdByType": "User",
    "createdAt": "2020-01-01T17:18:19.1234567Z",
    "lastModifiedBy": "user2",
    "lastModifiedByType": "User",
    "lastModifiedAt": "2020-01-02T17:18:19.1234567Z"
  },
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.AzureArcData/dataControllers/testdataController/activeDirectoryConnectors/testADConnector",
  "name": "testADConnector",
  "type": "Microsoft.AzureArcData/dataControllers/activeDirectoryConnectors"
}
{
  "properties": {
    "spec": {
      "activeDirectory": {
        "realm": "CONTOSO.LOCAL",
        "serviceAccountProvisioning": "manual",
        "domainControllers": {
          "primaryDomainController": {
            "hostname": "dc1.contoso.local"
          },
          "secondaryDomainControllers": [
            {
              "hostname": "dc2.contoso.local"
            },
            {
              "hostname": "dc3.contoso.local"
            }
          ]
        },
        "netbiosDomainName": "CONTOSO"
      },
      "dns": {
        "nameserverIPAddresses": [
          "11.11.111.111",
          "22.22.222.222"
        ],
        "replicas": 1,
        "preferK8sDnsForPtrLookups": false,
        "domainName": "contoso.local"
      }
    }
  },
  "systemData": {
    "createdBy": "user1",
    "createdByType": "User",
    "createdAt": "2020-01-01T17:18:19.1234567Z",
    "lastModifiedBy": "user2",
    "lastModifiedByType": "User",
    "lastModifiedAt": "2020-01-02T17:18:19.1234567Z"
  },
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.AzureArcData/dataControllers/testdataController/activeDirectoryConnectors/testADConnector",
  "name": "testADConnector",
  "type": "Microsoft.AzureArcData/dataControllers/activeDirectoryConnectors"
}

Definitions

Name Description
accountProvisioningMode

The service account provisioning mode for this Active Directory connector.

ActiveDirectoryConnectorDNSDetails

DNS server details

ActiveDirectoryConnectorDomainDetails

Active Directory domain details

ActiveDirectoryConnectorProperties

The properties of an Active Directory connector resource

ActiveDirectoryConnectorResource

Active directory connector resource

ActiveDirectoryConnectorSpec

The specifications of the AD Kubernetes resource.

ActiveDirectoryConnectorStatus

The status of the Kubernetes custom resource.

ActiveDirectoryDomainController

Information about a domain controller in the AD domain.

ActiveDirectoryDomainControllers

Details about the Active Directory domain controllers associated with this AD connector instance

BasicLoginInformation

Username and password for basic login authentication.

createdByType

The type of identity that created the resource.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

systemData

Metadata pertaining to creation and last modification of the resource.

accountProvisioningMode

The service account provisioning mode for this Active Directory connector.

Value Description
automatic
manual

ActiveDirectoryConnectorDNSDetails

DNS server details

Name Type Default value Description
domainName

string

DNS domain name for which DNS lookups should be forwarded to the Active Directory DNS servers.

nameserverIPAddresses

string[]

List of Active Directory DNS server IP addresses.

preferK8sDnsForPtrLookups

boolean

True

Flag indicating whether to prefer Kubernetes DNS server response over AD DNS server response for IP address lookups.

replicas

integer (int64)

1

Replica count for DNS proxy service. Default value is 1.

ActiveDirectoryConnectorDomainDetails

Active Directory domain details

Name Type Default value Description
domainControllers

ActiveDirectoryDomainControllers

null

netbiosDomainName

string

NETBIOS name of the Active Directory domain.

ouDistinguishedName

string

The distinguished name of the Active Directory Organizational Unit.

realm

string

Name (uppercase) of the Active Directory domain that this AD connector will be associated with.

serviceAccountProvisioning

accountProvisioningMode

manual

The service account provisioning mode for this Active Directory connector.

ActiveDirectoryConnectorProperties

The properties of an Active Directory connector resource

Name Type Description
domainServiceAccountLoginInformation

BasicLoginInformation

Username and password for domain service account authentication.

provisioningState

string

The provisioning state of the Active Directory connector resource.

spec

ActiveDirectoryConnectorSpec

null

status

ActiveDirectoryConnectorStatus

null

ActiveDirectoryConnectorResource

Active directory connector resource

Name Type Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

name

string

The name of the resource

properties

ActiveDirectoryConnectorProperties

null

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

ActiveDirectoryConnectorSpec

The specifications of the AD Kubernetes resource.

Name Type Description
activeDirectory

ActiveDirectoryConnectorDomainDetails

null

dns

ActiveDirectoryConnectorDNSDetails

null

ActiveDirectoryConnectorStatus

The status of the Kubernetes custom resource.

Name Type Description
lastUpdateTime

string

The time that the custom resource was last updated.

observedGeneration

integer (int64)

The version of the replicaSet associated with the AD connector custom resource.

state

string

The state of the AD connector custom resource.

ActiveDirectoryDomainController

Information about a domain controller in the AD domain.

Name Type Description
hostname

string

Fully-qualified domain name of a domain controller in the AD domain.

ActiveDirectoryDomainControllers

Details about the Active Directory domain controllers associated with this AD connector instance

Name Type Description
primaryDomainController

ActiveDirectoryDomainController

Information about the Primary Domain Controller (PDC) in the AD domain.

secondaryDomainControllers

ActiveDirectoryDomainController[]

null

BasicLoginInformation

Username and password for basic login authentication.

Name Type Description
password

string

Login password.

username

string

Login username.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.